import pandas as pd
import matplotlib.pyplot as plt
import sys

if len(sys.argv) < 3:
    print("Usage: python script.py input_csv_file output_pdf_file")
    sys.exit(1)

file_path = sys.argv[1]
output_file_path = sys.argv[2]

data = pd.read_csv(file_path, header=None)  

plt.figure(figsize=(10, 8))  
plt.imshow(data, cmap='hot', interpolation='nearest') 
plt.colorbar() 

plt.savefig(output_file_path, bbox_inches='tight')

plt.close()